package JCPC.core.device.crtc;

/**
 * Title:        JCPC
 * Description:  The Java Emulation Platform
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public interface CRTCListener {

  public void hSyncStart();

  public void hSyncEnd();
  
  public void cycle();
  
  public void vDispStart();

  public void hDispStart();
  
  public void vSyncStart();

  public void vSyncEnd();

  public void hDispEnd();

  public void cursor();
  
  public void modeCheck();

  public int[] getField();
  
  public int PEEK(int address);

  public void POKE(int address, int value);

  public int getScreenMode();
}