package JCPC.core.device.memory;

import JCPC.core.device.Device;

/**
 * Title:        JCPC
 * Description:  The Java Emulation Platform
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */
public abstract class Memory extends Device {

    public static final int KB = 1024;
    public static final int MB = 1024 * KB;
    protected int size;

    public Memory(String type, int size) {
        super(type);
        this.size = size;
    }

    public int getAddressSize() {
        return size;
    }

    public int readByte(int address, Object config) {
        return readByte(address);
    }

    public void writeByte(int address, int value, Object config) {
        writeByte(address, value);
    }
}