/*
 * SoundPlayer.java
 *
 * Created on 4 August 2006, 17:11
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package JCPC.core.device.sound;

import JCPC.core.device.*;

/**
 *
 * @author Richard
 */
public abstract class SoundPlayer implements ComputerTimer {     // Probably should be an interface, but how efficient are they?
  
  protected int format = SoundUtil.ULAW;
  
  public int getClockAdder(int test, int cyclesPerSecond) {
    return (int)((long)test * (long)getSampleRate() / (long)cyclesPerSecond);
  }

  public abstract int getSampleRate();

  public abstract void writeStereo(int a, int b);
  
  public abstract void play();
  
  public abstract void stop();
  
  public abstract void resync();
  
  public abstract void dispose();
  
  public void setFormat(int value) {
    format = value;
  }
  
  public int getFormat() {
    return format;
  }
  
}
