/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package JCPC.ui;

import java.awt.*;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.image.BufferedImage;
import java.net.URL;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;

/**
 *
 * @author Markus
 */
public class Controller extends javax.swing.JFrame implements KeyListener {

    public void keyPressed(KeyEvent e){}
    public void keyReleased(KeyEvent e){
        if (e.getKeyCode() >= KeyEvent.VK_F1 && e.getKeyCode() <= KeyEvent.VK_F24){
            return;
        }
        if (e.getKeyCode() == KeyEvent.VK_CONTROL){
            return;
        }
        if (e.getKeyCode() == KeyEvent.VK_SHIFT){
            return;
        }
        if (e.getKeyCode() == KeyEvent.VK_CAPS_LOCK){
            return;
        }
        if (e.getKeyCode() == KeyEvent.VK_ALT){
            return;
        }
        if (e.getKeyCode() == KeyEvent.VK_ALT_GRAPH){
            return;
        }
        keyevents[keyindex] = e.getKeyCode();
        keychars[keyindex] = e.getKeyChar();
        keylocs[keyindex] = (e.getKeyLocation()==4?"NP_":"KB_");
        this.removeKeyListener(this);
        changekey = false;
        updateController();
    }
    public void keyTyped(KeyEvent e){}
    /**
     * Creates new form Controller
     */
    public Controller() {
        initComponents();
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        this.setLocation((d.width - this.getSize().width) / 2, (d.height - this.getSize().height) / 2);
        updateController();
    }
    
    public int[] keyevents = {
        KeyEvent.VK_NUMPAD5,
        KeyEvent.VK_NUMPAD0,
        KeyEvent.VK_NUMPAD8,
        KeyEvent.VK_NUMPAD2,
        KeyEvent.VK_NUMPAD4,
        KeyEvent.VK_NUMPAD6,
    };
    char[] keychars = {
        '5',
        '0',
        '8',
        '2',
        '4',
        '5'
    };
    String[] keylocs = {
        "NP_",
        "NP_",
        "NP_",
        "NP_",
        "NP_",
        "NP_"
    };
    int keyindex;
    boolean changekey = false;
    
    public void setButton(int index){
        keyindex = index;
        changekey = true;
        updateController();
        this.addKeyListener(this);
    }
    
    public char getButton(int index){
        char result = keychars[index];
        return result;
    }
    
    String[] loc = {
        "Fire 1",
        "Fire 2",
        "Up",
        "Down",
        "Left",
        "Right",
    };
    final URL img = getClass().getResource("/JCPC/ui/controller.png");
    BufferedImage panel;
    public void updateController(){
        try{
            panel=ImageIO.read(img);
            Graphics c = panel.createGraphics();
            c.setColor(Color.green);
            if (changekey){
                c.drawString("Press desired key:", 120, 30);
                c.drawString("Press desired key:", 121, 30);
                c.drawString(loc[keyindex], 120, 50);
                c.drawString(loc[keyindex], 121, 50);
                this.requestFocus();
            }
            c.setColor(Color.blue);
            c.drawString(""+keylocs[0]+(keychars[0]==' '?"spc":keychars[0]), 243, 90);
            c.drawString(""+keylocs[0]+(keychars[0]==' '?"spc":keychars[0]), 244, 90);
            c.drawString(""+keylocs[1]+(keychars[1]==' '?"spc":keychars[1]), 296, 90);
            c.drawString(""+keylocs[1]+(keychars[1]==' '?"spc":keychars[1]), 297, 90);
            
            c.drawString(""+keylocs[2]+(keychars[2]==' '?"spc":keychars[2]), 50, 50);
            c.drawString(""+keylocs[2]+(keychars[2]==' '?"spc":keychars[2]), 51, 50);
            
            c.drawString(""+keylocs[3]+(keychars[3]==' '?"spc":keychars[3]), 50, 154);
            c.drawString(""+keylocs[3]+(keychars[3]==' '?"spc":keychars[3]), 51, 154);
            
            c.drawString(""+keylocs[4]+(keychars[4]==' '?"spc":keychars[4]), 1, 100);
            c.drawString(""+keylocs[4]+(keychars[4]==' '?"spc":keychars[4]), 2, 100);
            
            c.drawString(""+keylocs[5]+(keychars[5]==' '?"spc":keychars[5]), 110, 100);
            c.drawString(""+keylocs[5]+(keychars[5]==' '?"spc":keychars[5]), 111, 100);
            jLabel1.setIcon(new ImageIcon(panel));
        }catch (Exception e){}
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        trojan = new javax.swing.JCheckBox();
        cart = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();

        setTitle("Gamepad Options");
        setResizable(false);

        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/JCPC/ui/controller.png"))); // NOI18N
        jLabel1.setFocusable(false);
        jLabel1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jLabel1MouseReleased(evt);
            }
        });
        jLabel1.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                jLabel1MouseMoved(evt);
            }
        });
        getContentPane().add(jLabel1, java.awt.BorderLayout.CENTER);

        jPanel1.setLayout(new java.awt.BorderLayout());

        trojan.setText("Enable Trojan Lightgun");
        trojan.setFocusPainted(false);
        trojan.setFocusable(false);
        jPanel1.add(trojan, java.awt.BorderLayout.WEST);

        cart.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jPanel1.add(cart, java.awt.BorderLayout.EAST);

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("Select Cartridge  ");
        jPanel1.add(jLabel2, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_END);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jLabel1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel1MouseReleased
        int x = evt.getX();
        int y = evt.getY();
        if (y > 100 && y < 132) {
            if (x > 244 && x < 276) {
                System.out.println("button 1");
                setButton(0);
            }
            if (x > 290 && x < 328) {
                System.out.println("button 2");
                setButton(1);
            }
        }
        if (x > 50 && x < 75) {
            if (y > 56 && y < 84) {
                System.out.println("button up");
                setButton(2);
            }
            if (y > 110 && y < 132) {
                System.out.println("button down");
                setButton(3);
            }
        }
        if (y > 84 && y < 110) {
            if (x < 50 && x > 28) {
                System.out.println("button left");
                setButton(4);
            }
            if (x > 75 && x < 100) {
                System.out.println("button right");
                setButton(5);
            }
        }
    }//GEN-LAST:event_jLabel1MouseReleased

    private void jLabel1MouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel1MouseMoved
        int x = evt.getX();
        int y = evt.getY();
        jLabel1.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        if (y > 100 && y < 132) {
            if (x > 244 && x < 276) {
                jLabel1.setCursor(new Cursor(Cursor.HAND_CURSOR));
            } else if (x > 290 && x < 328) {
                jLabel1.setCursor(new Cursor(Cursor.HAND_CURSOR));
            }
        }
        if (x > 50 && x < 75) {
            if (y > 56 && y < 84) {
                jLabel1.setCursor(new Cursor(Cursor.HAND_CURSOR));
            }
            if (y > 110 && y < 132) {
                jLabel1.setCursor(new Cursor(Cursor.HAND_CURSOR));
            }
        }
        if (y > 84 && y < 110) {
            if (x < 50 && x > 28) {
                jLabel1.setCursor(new Cursor(Cursor.HAND_CURSOR));
            }
            if (x > 75 && x < 100) {
                jLabel1.setCursor(new Cursor(Cursor.HAND_CURSOR));
            }

        }
    }//GEN-LAST:event_jLabel1MouseMoved

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the
         * default look and feel. For details see
         * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Controller.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Controller.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Controller.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Controller.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /*
         * Create and display the form
         */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new Controller().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JComboBox cart;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    public javax.swing.JCheckBox trojan;
    // End of variables declaration//GEN-END:variables
}
